// $Id: chainout.cpp,v 1.13 2011/02/20 04:13:59 bobgian Exp $

/*
  Copyright 2002 Peter Beerli, Mary Kuhner, Jon Yamato and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

#include "chainout.h"

#ifdef DMALLOC_FUNC_CHECK
#include "/usr/local/include/dmalloc.h"
#endif

ChainOut::ChainOut()
    : m_badtrees(FLAGLONG),
      m_tinypoptrees(FLAGLONG),
      m_zerodltrees(FLAGLONG),
      m_stretchedtrees(FLAGLONG),
      m_accrate(FLAGDOUBLE),
      m_numtemps(FLAGLONG),
      m_swaprates(),
      m_tempaccrates(),
      m_temperatures(),
      m_bayesunique(),
      m_starttime(0),
      m_endtime(0),
      m_estimates(unknown_region),
      m_llikemle(FLAGDOUBLE),
      m_llikedata(NEG_MAX)
{
    // deliberately blank
} // ChainOut

//------------------------------------------------------------------------------------

void ChainOut::SetStarttime()
{
#ifdef NOTIME_FUNC
    // The system does not provide a clock.  All times are 0.
    m_starttime = 0;
#else
    // Return "real" time.
    m_starttime = time(NULL);
#endif
}

//------------------------------------------------------------------------------------

void ChainOut::SetEndtime()
{
#ifdef NOTIME_FUNC
    // The system does not provide a clock.  All times are 0.
    m_endtime = 0;
#else
    // Return "real" time.
    m_endtime = time(NULL);
#endif
}

//____________________________________________________________________________________
