// $Id: lamarc.h,v 1.24 2011/04/07 02:15:44 ewalkup Exp $

/*
  Copyright 2002 Peter Beerli, Mary Kuhner, Jon Yamato and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

/***************************************************************
 This file (not a class at this time) contains the main driver
 routines for LAMARC.  It does the following:

 (1) Set up registry (main)
 (2) Accept user input (DoUserInput)
 (3) Finalize registry (FinishRegistry)
 (4) Launch chain manager (main)

 Mary Kuhner (based on work by Jon Yamato) April 2001
***************************************************************/

#ifndef LAMARC_H
#define LAMARC_H

class UIInterface;

extern void GetCloseConfirmation();
extern void ParseOptions(long argc, char** argv, bool* isBatch, bool* explicitExit, bool* hasFile, std::string & infileName);
extern bool DoUserInput(long argc, char** argv);
extern void FinishRegistry(UIInterface&);

#if defined(LAMARC_COMPILE_LINUX) || defined(LAMARC_COMPILE_MACOSX)
extern void CatchFileTooBigSignal(int signal);
#endif

extern int main(int, char **);

//------------------------------------------------------------------------------------
// Declarations for function and variables used in timing tests.

#ifdef LAMARC_QA_TIMINGTEST

// Global variable holds CPU cycle count at start of program.
extern unsigned long long int TestRunStartTime;

// Global variable accumulates CPU cycle count measuring execution time of test function.
extern unsigned long long int TestFcnAccumTime;

// Global counter for calls to test function.
extern unsigned long int TestFcnCallCount;

#endif // LAMARC_QA_TIMINGTEST

//------------------------------------------------------------------------------------

#endif // LAMARC_H

//____________________________________________________________________________________
