// $Id: gc_creation_info.h,v 1.4 2011/03/08 19:22:00 bobgian Exp $

/*
  Copyright 2002  Mary Kuhner, Jon Yamato, and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

#ifndef GC_CREATION_INFO_H
#define GC_CREATION_INFO_H

#include "wx/string.h"

enum gcCreationType
{
    created_UNKNOWN,
    created_CMDFILE,
    created_DATAFILE,
    created_GUI
};

class gcCreationInfo
{
  private:

  protected:
    gcCreationType      m_creationType;

    bool                m_hasLineNumber;
    size_t              m_lineNumber;

    // EWFIX.P3.BUG.766 -- consider refering to actual file object
    bool                m_hasFileName;
    wxString            m_fileName;

    void    SetLineNumber(size_t lineNumber);
    void    SetFileName(wxString fileName);

  public:
    gcCreationInfo();
    ~gcCreationInfo();

    bool        HasLineNumber() const;
    size_t      GetLineNumber() const;

    bool        HasFileName() const;
    wxString    GetFileName() const;

    wxString    GetDescriptiveName() const;

    static gcCreationInfo MakeGuiCreationInfo();
    static gcCreationInfo MakeDataFileCreationInfo(size_t lineNumber,wxString fileName);
    static gcCreationInfo MakeCmdFileCreationInfo(size_t lineNumber,wxString fileName);

};

#endif  // GC_CREATION_INFO_H

//____________________________________________________________________________________
