// $Id: gc_dictionary.h,v 1.4 2011/03/08 19:22:00 bobgian Exp $

/*
  Copyright 2002  Mary Kuhner, Jon Yamato, and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

#ifndef GC_DICTIONARY_H
#define GC_DICTIONARY_H

#include "wx/string.h"
#include <set>

class gcDictionary : private std::set<wxString>
{
  private:

  protected:
    // tells you what types of things are in this dictionary
    virtual const wxString &    infoString() const = 0;

  public:
    gcDictionary();
    virtual ~gcDictionary();

    bool        HasName     (const wxString & name) const;
    void        FreeName    (const wxString & name);
    void        ReserveName (const wxString & name);
    wxString    ReserveOrMakeName(  wxString useIfNotEmpty,
                                    wxString prefixIfCreatingName=wxEmptyString);
};

#endif  // GC_DICTIONARY_H

//____________________________________________________________________________________
