// $Id: gc_panel.h,v 1.1 2011/06/22 18:22:22 jmcgill Exp $

/*
  Copyright 2002  Mary Kuhner, Jon Yamato, and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

#ifndef GC_PANEL_H
#define GC_PANEL_H

#include "wx/string.h"
#include "gc_creation_info.h"
#include "gc_phase.h"
#include "gc_quantum.h"
#include "gc_types.h"

class GCStructures;

class gcPanel : public GCQuantum
{
    friend class GCStructures;

  private:
    bool                        m_blessed;  // true if user has edited m_nPanels

    bool                        m_hasRegion;
    size_t                      m_regionId;

    bool                        m_hasPop;
    size_t                      m_popId;
    
    long                        m_nPanels;
    
    gcCreationInfo              m_creationInfo;  //JRM this doing anything?
    
    void   SetCreationInfo(const gcCreationInfo &);
    
  public:

    gcPanel();
    ~gcPanel();

    void        SetBlessed(bool blessed);
    bool        GetBlessed()            const;

    bool        HasRegion()             const;
    void        SetRegionId(size_t id);
    void        UnsetRegionId();
    size_t      GetRegionId()           const;
    wxString    GetRegionIdString()     const;

    bool        HasPop()                const;
    void        SetPopId(size_t id);
    void        UnsetPopId();
    size_t      GetPopId()              const;
    wxString    GetPopIdString()        const;
    
    void        SetNumPanels(long val);
    long        GetNumPanels()          const;
    wxString    GetNumPanelsString()    const;


    void        DebugDump(wxString prefix=wxEmptyString) const;

};

#endif  // GC_PANEL_H

//____________________________________________________________________________________
