// $Id: gc_parent.h,v 1.2 2012/02/15 18:13:41 jmcgill Exp $

/*
  Copyright 2002  Mary Kuhner, Jon Yamato, and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

#ifndef GC_PARENT_H
#define GC_PARENT_H

#include "wx/string.h"
#include "gc_creation_info.h"
#include "gc_phase.h"
#include "gc_quantum.h"
#include "gc_types.h"

class GCStructures;

class gcParent : public GCQuantum
{
    friend class GCStructures;

  private:
    bool                        m_blessed;
    int                         m_level;      // for lam_conv display layout
    int                         m_index;      // for lam_conv display layout
    int                         m_length;     // for lam_conv display layout
    bool                        m_hasChild1;
    size_t                      m_child1Id;
    bool                        m_hasChild2;
    size_t                      m_child2Id;    
    bool                        m_hasParent;
    size_t                      m_parentId;
    
    gcCreationInfo              m_creationInfo;  //JRM this doing anything?
    
    void   SetCreationInfo(const gcCreationInfo &);
    
  public:

    gcParent();
    ~gcParent();

    void        SetBlessed(bool blessed);
    bool        GetBlessed()            const;
    
    int         GetDispLevel()          const;
    void        SetDispLevel(int level);
    int         GetDispIndex()          const;
    void        SetDispIndex(int index);
    int         GetDispLength()         const;
    void        SetDispLength(int length);

    void        SetChild1Id(size_t id);
    void        ClearChild1Id();
    bool        HasChild1()             const;
    size_t      GetChild1Id()           const;
    size_t      GetChild1Id();
    wxString    GetChild1IdString()     const;

    void        SetChild2Id(size_t id);
    void        ClearChild2Id();
    bool        HasChild2()             const;
    size_t      GetChild2Id()           const;
    size_t      GetChild2Id();
    wxString    GetChild2IdString()     const;

    void        SetParentId(size_t id);
    void        ClearParentId();
    bool        HasParent()             const;
    size_t      GetParentId()           const;
    size_t      GetParentId();
    wxString    GetParentIdString()     const;

    void        DebugDump(wxString prefix=wxEmptyString) const;

};

#endif  // GC_PARENT_H

//____________________________________________________________________________________
