// $Id: gc_phase.h,v 1.9 2011/03/08 19:22:00 bobgian Exp $

/*
  Copyright 2002  Mary Kuhner, Jon Yamato, and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

#ifndef GC_PHASE_H
#define GC_PHASE_H

#include "wx/string.h"
#include <set>

class gcLocus;

class gcUnphasedMarkers : private std::set<long>
// represents the markers which
{
  private:

  protected:

  public:
    gcUnphasedMarkers();
    virtual ~gcUnphasedMarkers();

    wxString        AsString()      const;
    size_t          NumMarkers()    const;

    long            Smallest()      const;
    long            Largest ()      const;

    void            AddMarker(long marker);
    void            Merge(const gcUnphasedMarkers& );
    void            ReadFromString(wxString line);

    void            DebugDump(wxString prefix=wxEmptyString) const;

    bool            operator!=(const gcUnphasedMarkers&) const;
    bool            HasZero() const;

    void            ShiftNegsUp();
    void            CheckAgainstLocations(const gcLocus&) const;
};

#endif  // GC_PHASE_H

//____________________________________________________________________________________
