// $Id: gc_trait_allele.h,v 1.5 2011/03/08 19:22:00 bobgian Exp $

/*
  Copyright 2002  Mary Kuhner, Jon Yamato, and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

#ifndef GC_TRAIT_ALLELE_H
#define GC_TRAIT_ALLELE_H

#include "gc_quantum.h"
#include "wx/string.h"

class gcTraitAllele : public GCQuantum
{
    friend class GCStructures;

  private:
    bool                            m_hasTraitId;
    size_t                          m_traitId;

    void    SetTraitId(size_t traitId);
    void    UnsetTraitId();

  protected:

  public:
    gcTraitAllele();
    virtual ~gcTraitAllele();

    bool    HasTraitId()    const;
    size_t  GetTraitId()    const;

    virtual void    SetName(wxString name); // overrides gc_quantum version
    // so name can be checked for spaces
};

#endif  // GC_TRAIT_ALLELE_H

//____________________________________________________________________________________
