// $Id: tixml_util.h,v 1.8 2011/03/08 19:22:00 bobgian Exp $

/*
  Copyright 2002  Mary Kuhner, Jon Yamato, and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

#ifndef TIXML_UTIL_H
#define TIXML_UTIL_H

#include "errhandling.h"
#include "wx/string.h"

#include <string>
#include <vector>

class TiXmlElement;

TiXmlElement *          tiwx_optionalChild(TiXmlElement* ancestor, wxString nodeName);
TiXmlElement *          tiwx_requiredChild(TiXmlElement* ancestor, wxString nodeName);
wxString                tiwx_nodeText(TiXmlElement *);
wxString                tiwx_attributeValue(TiXmlElement*,wxString attributeName);

double                  tiwx_double_from_text(TiXmlElement *);
long                    tiwx_long_from_text(TiXmlElement *) throw (incorrect_xml);
size_t                  tiwx_size_t_from_text(TiXmlElement *) throw (incorrect_xml);

std::vector<TiXmlElement *>  tiwx_optionalChildren(TiXmlElement* ancestor, wxString nodeName);
std::vector<TiXmlElement *>  tiwx_requiredChildren(TiXmlElement* ancestor, wxString nodeName);

#endif  // TIXML_UTIL_H

//____________________________________________________________________________________
