// $Id: Converter_types.h,v 1.5 2010/03/19 23:16:44 bobgian Exp $

/*
  Copyright 2002 Patrick Colacurcio, Peter Beerli, Mary Kuhner,
  Jon Yamato and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

#ifndef CONVERTER_TYPES_H
#define CONVERTER_TYPES_H

#include <string>
#include "stringx.h"
#include <map>
#include <set>

using std::string;
using std::map;
using std::vector;

class PopulationDS;
class RegionDS;
class IndividualDS;

typedef map<string, PopulationDS, CIStringCompare> PopMap;
typedef map<string, RegionDS, CIStringCompare> RegionMap;
typedef map<IndividualDS, string> IndividualMap;

typedef PopMap::iterator popmapiterator;
typedef vector<popmapiterator> PopIterVec;
typedef map<string, PopIterVec, CIStringCompare> PopIterMap;
typedef map<string, PopIterMap, CIStringCompare> RegByPopMap;

typedef map<string, vector<long>, CIStringCompare> SpaceMap;

typedef map<string, long, CIStringCompare> MarkerMap;
typedef map<string, string, CIStringCompare> TypeMap;

typedef std::set<string, CIStringCompare> PopNameSet;
typedef map<string, PopNameSet, CIStringCompare> RegPopNameMap;

#endif // CONVERTER_TYPES_H

//____________________________________________________________________________________
