// $Id: DataSourceException.cpp,v 1.3 2011/03/08 19:22:00 bobgian Exp $

/*
  Copyright 2002  Mary Kuhner, Jon Yamato, and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

#include "Converter_DataSourceException.h"
#include "stringx.h"

MarkerLengthMismatchDataError::MarkerLengthMismatchDataError(long front, long back, long length)
    : InconsistentDataError("The input length ("
                            +   ToString(length)
                            +   ") is less than the length covered by the markers ("
                            +   ToString(back)
                            +   " - "
                            +   ToString(front)
                            +   " + 1 = "
                            +   ToString(back-front+1)
                            +   ")")
{
}

OffsetAfterFirstPositionDataError::OffsetAfterFirstPositionDataError(long offset, long firstPosition)
    :   InconsistentDataError("First position of sequence ("
                              +   ToString(firstPosition)
                              +   ") is before the sequence offset ("
                              +   ToString(offset)
                              +   ")")
{
}

RegionEndBeforeLastPositionDataError::RegionEndBeforeLastPositionDataError(long offset, long length, long lastPosition)
    :   InconsistentDataError("End of region (position "
                              +   ToString(offset+length-1)
                              +   " = offset ("
                              +   ToString(offset)
                              +   ") + length ("
                              +   ToString(length)
                              +   ") - 1) is before last position ("
                              +   ToString(lastPosition)
                              +   ")"
        )
{
}

MarkerPositionMismatchDataError::MarkerPositionMismatchDataError(long nmarkers, long npositions)
    : InconsistentDataError("There are "
                            +   ToString(nmarkers)
                            +   ", but only "
                            +   ToString(npositions)
                            +   " positions for them to occupy")
{
}

//____________________________________________________________________________________
