// $Id: nomenuglobals.h,v 1.9 2011/03/08 19:22:00 bobgian Exp $

/*
  Copyright 2002  Mary Kuhner, Jon Yamato, and Joseph Felsenstein

  This software is distributed free of charge for non-commercial use
  and is copyrighted.  Of course, we do not guarantee that the software
  works, and are not responsible for any damage you may cause or have.
*/

// This file defines the behaviour of the converter when compiled with the JSIM flag

#ifndef CONV_JSIMGLOBALS_H
#define CONV_JSIMGLOBALS_H

#ifdef JSIM
#include <string>

using std::string;

class convstr
{
  public:
    // the following are mandatory--they must exist
    static string GENETICDATAFILENAME;
    static string OUTFILENAME;
    // end mandatory

    static const string    JSIMPARMFILE; // empty or filename

    static string    HAPFILENAME;          // empty or filename
    static string    MAPFILENAME;          // empty or filename
    static string    GENETICDATATYPE;
    static string    GENETICDATAFORMAT;    // Phylip or Migrate
    static bool      GENETICDATAINTERLEAVED;
    static long      REGIONLENGTH;
    static long      REGIONOFFSET;
    static long      LOCUSMAPPOS;          // what's the locus' map-position?
    // empty = no mapping
    static bool      MICROREGIONS;         // are microsats unlinked
    // (and therefore analyzed as separate regions)?
};

#endif  // JSIM

#endif // CONV_JSIMGLOBALS_H

//____________________________________________________________________________________
